<script>
    import { T } from "@threlte/core";
    import { OrbitControls as ThreeOrbitControls } from "three/examples/jsm/controls/OrbitControls.js";

    import Camera from "./Camera.svelte";
    import Earth from "./Earth.svelte";
    import Graticule from "./Graticule.svelte";
    import Orbit from "./Orbit.svelte";
    import Stars from "./Stars.svelte";

    import dayjs from "dayjs";
    import utc from "dayjs";
    dayjs.extend(utc);

    export let subplot;
    export let xScale;
    export let height;
    export let width;
    export let x_position = 0.5;
    export let earthradii = 2.5;

    let epoch_dayjs = dayjs();
    $: epoch_dayjs = dayjs(xScale.domain()[0]).add(
        x_position * dayjs(xScale.domain()[1]).diff(dayjs(xScale.domain()[0])),
        "ms",
    );

    const sun_spherical_coords = function (epoch) {
        var t2000 = epoch.diff(utc("2000-01-01T12:00:00Z"));
        var t2000centuries = t2000 / 86400e3 / 36525.0;
        const deg2rad = 3.141592 / 180;
        const ecliptic = 23.43929111 * deg2rad;
        const M = 357.5256 * deg2rad + 35999.049 * deg2rad * t2000centuries;
        const lambda_sun =
            282.94 * deg2rad +
            M +
            ((deg2rad * 6892) / 3600) * Math.sin(M) +
            ((deg2rad * 72) / 3600) * Math.sin(2 * M);
        let rsun =
            (149.619 - 2.499 * Math.cos(M) - 0.021 * Math.cos(2 * M)) * 1e6;
        return { r: rsun, lambda: lambda_sun, ecliptic: ecliptic };
    };

    const sun_position = function (epoch) {
        let sun_sph = sun_spherical_coords(epoch);
        let sunx = sun_sph.r * Math.cos(sun_sph.lambda);
        let sunz =
            -sun_sph.r * Math.sin(sun_sph.lambda) * Math.cos(sun_sph.ecliptic);
        let suny =
            sun_sph.r * Math.sin(sun_sph.lambda) * Math.sin(sun_sph.ecliptic);
        return [sunx, suny, sunz];
    };

    const earth_rotation_angle = function (epoch) {
        var t2000 = epoch.diff(utc("2000-01-01T12:00:00Z"));
        var t2000centuries = t2000 / 86400e3 / 36525.0;
        let sec_in_day =
            -1 * epoch.utcOffset() * 60 +
            epoch.hour() * 3600 +
            epoch.minute() * 60 +
            epoch.second() +
            epoch.millisecond() / 1e3;
        let gmst =
            24110.54841 +
            8640184.812866 * t2000centuries +
            1.002747909350795 * sec_in_day +
            0.093104 * t2000centuries ** 2 -
            0.000062 * t2000centuries ** 3;
        return 2 * 3.14159267 * (gmst / 86400);
    };

    $: sun_sph = sun_spherical_coords(epoch_dayjs);
    $: sunpos = sun_position(epoch_dayjs);

    let camera_position = subplot.options_3d.camera_position
        ? subplot.options_3d.camera_position
        : [0, 3, 0];
    $: orbit_controls_enabled = subplot.options_3d.orbit_controls_enabled;
    let type = "perspective";
</script>

{#if subplot.options_3d.stars}
    <Stars />
{/if}
{#if subplot.options_3d.camera_attached_to == "Sun"}
    <T.Group rotation={[0, sun_sph.lambda - 3.141592 / 2, 0]}>
        <Camera {height} position={camera_position} {orbit_controls_enabled} />
    </T.Group>
{:else if subplot.options_3d.camera_attached_to == "Inertial"}
    <Camera {width} {height} position={camera_position} />
{/if}
<T.AmbientLight intensity={0.5} />
<T.DirectionalLight position={sun_position(epoch_dayjs)} intensity={2.5} />
<T.Group rotation={[0, earth_rotation_angle(epoch_dayjs), 0]}>
    {#if subplot.options_3d.camera_attached_to == "Earth"}
        {#if "clip_far" in subplot.options_3d}
            <Camera
                {height}
                {type}
                position={camera_position}
                {orbit_controls_enabled}
                clip_far={subplot.options_3d.clip_far} />
        {:else}
            <Camera
                {height}
                {type}
                position={camera_position}
                {orbit_controls_enabled} />
        {/if}
    {/if}
    {#each subplot.plot_elements as plot_element}
        {#if plot_element.plot_options.plot_type == "orbit_on_globe" && plot_element.visible && plot_element.plot_options.frame == "EarthFixed"}
            <Orbit {subplot} {plot_element} epoch={epoch_dayjs} {x_position} />
        {/if}
    {/each}
    <Earth {subplot} />
    {#if subplot.options_3d.render_graticule_magnetic && (xScale.domain()[1] - xScale.domain()[0] < 32 * 86400e3)}
        <Graticule {subplot} />
    {/if}
</T.Group>
{#each subplot.plot_elements as plot_element}
    {#if plot_element.plot_options.plot_type == "orbit_on_globe" && plot_element.visible && plot_element.plot_options?.frame != "EarthFixed"}
        <Orbit {subplot} {plot_element} epoch={epoch_dayjs} {x_position} />
    {/if}
{/each}
